Lucene++ - a full-featured, c++ search engine
API Documentation

Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes
Lucene::BaseCharFilter Class Reference

Base utility class for implementing a CharFilter. You subclass this, and then record mappings by calling addOffCorrectMap, and then invoke the correct method to correct an offset. More...

`#include <BaseCharFilter.h>`

Inheritance diagram for Lucene::BaseCharFilter:

## Public Member Functions

| BaseCharFilter (const CharStreamPtr &in)
virtual | ~BaseCharFilter ()
virtual String | getClassName ()
boost::shared_ptr< BaseCharFilter > | shared_from_this ()
Public Member Functions inherited from Lucene::CharFilter
virtual | ~CharFilter ()
boost::shared_ptr< CharFilter > | shared_from_this ()
Public Member Functions inherited from Lucene::CharStream
virtual | ~CharStream ()
boost::shared_ptr< CharStream > | shared_from_this ()
Public Member Functions inherited from Lucene::Reader
virtual | ~Reader ()
boost::shared_ptr< Reader > | shared_from_this ()
virtual int32_t | read ()
| Read a single character. More...
virtual int64_t | skip (int64_t n)
| Skip characters. More...
virtual int64_t | length ()
| The number of bytes in the stream. More...
Public Member Functions inherited from Lucene::LuceneObject
virtual | ~LuceneObject ()
virtual void | initialize ()
| Called directly after instantiation to create objects that depend on this object being fully constructed. More...
virtual LuceneObjectPtr | clone (const LuceneObjectPtr &other=LuceneObjectPtr())
| Return clone of this object. More...
virtual int32_t | hashCode ()
| Return hash code for this object. More...
virtual bool | equals (const LuceneObjectPtr &other)
| Return whether two objects are equal. More...
virtual int32_t | compareTo (const LuceneObjectPtr &other)
| Compare two objects. More...
virtual String | toString ()
| Returns a string representation of the object. More...
Public Member Functions inherited from Lucene::LuceneSync
virtual | ~LuceneSync ()
virtual SynchronizePtr | getSync ()
| Return this object synchronize lock. More...
virtual LuceneSignalPtr | getSignal ()
| Return this object signal. More...
virtual void | lock (int32_t timeout=0)
| Lock this object using an optional timeout. More...
virtual void | unlock ()
| Unlock this object. More...
virtual bool | holdsLock ()
| Returns true if this object is currently locked by current thread. More...
virtual void | wait (int32_t timeout=0)
| Wait for signal using an optional timeout. More...
virtual void | notifyAll ()
| Notify all threads waiting for signal. More...

## Static Public Member Functions

static String | _getClassName ()
Static Public Member Functions inherited from Lucene::CharFilter
static String | _getClassName ()
Static Public Member Functions inherited from Lucene::CharStream
static String | _getClassName ()
Static Public Member Functions inherited from Lucene::Reader
static String | _getClassName ()

## Protected Member Functions

virtual int32_t | correct (int32_t currentOff)
| Retrieve the corrected offset. More...
int32_t | getLastCumulativeDiff ()
void | addOffCorrectMap (int32_t off, int32_t cumulativeDiff)
Protected Member Functions inherited from Lucene::CharFilter
| CharFilter (const CharStreamPtr &in)
virtual int32_t | correctOffset (int32_t currentOff)
| Chains the corrected offset through the input CharFilter. More...
virtual void | close ()
| Close the stream. More...
virtual int32_t | read (wchar_t *buffer, int32_t offset, int32_t length)
| Read characters into a portion of an array. More...
virtual bool | markSupported ()
| Tell whether this stream supports the mark() operation. More...
virtual void | mark (int32_t readAheadLimit)
| Mark the present position in the stream. Subsequent calls to reset() will attempt to reposition the stream to this point. More...
virtual void | reset ()
| Reset the stream. If the stream has been marked, then attempt to reposition it at the mark. If the stream has not been marked, then attempt to reset it in some way appropriate to the particular stream, for example by repositioning it to its starting point. More...
Protected Member Functions inherited from Lucene::Reader
| Reader ()
Protected Member Functions inherited from Lucene::LuceneObject
| LuceneObject ()

## Protected Attributes

IntArray | offsets
IntArray | diffs
int32_t | size
Protected Attributes inherited from Lucene::CharFilter
CharStreamPtr | input
Protected Attributes inherited from Lucene::LuceneSync
SynchronizePtr | objectLock
LuceneSignalPtr | objectSignal

## Additional Inherited Members

Static Public Attributes inherited from Lucene::Reader
static const int32_t | READER_EOF

## Detailed Description

Base utility class for implementing a CharFilter. You subclass this, and then record mappings by calling addOffCorrectMap, and then invoke the correct method to correct an offset.

## Constructor & Destructor Documentation

## ◆ BaseCharFilter()

Lucene::BaseCharFilter::BaseCharFilter | ( | const CharStreamPtr & | in | ) |

## ◆ ~BaseCharFilter()

virtual Lucene::BaseCharFilter::~BaseCharFilter | ( |  | ) |

virtual

## Member Function Documentation

## ◆ _getClassName()

static String Lucene::BaseCharFilter::_getClassName | ( |  | ) |

inline static

## ◆ addOffCorrectMap()

void Lucene::BaseCharFilter::addOffCorrectMap | ( | int32_t | off,
|  | int32_t | cumulativeDiff
| ) |  |

protected

## ◆ correct()

virtual int32_t Lucene::BaseCharFilter::correct | ( | int32_t | currentOff | ) |

protected virtual

Retrieve the corrected offset.

Reimplemented from Lucene::CharFilter.

## ◆ getClassName()

virtual String Lucene::BaseCharFilter::getClassName | ( |  | ) |

inline virtual

Reimplemented from Lucene::CharFilter.

Reimplemented in Lucene::MappingCharFilter.

## ◆ getLastCumulativeDiff()

int32_t Lucene::BaseCharFilter::getLastCumulativeDiff | ( |  | ) |

protected

## ◆ shared_from_this()

boost::shared_ptr< BaseCharFilter > Lucene::BaseCharFilter::shared_from_this | ( |  | ) |

inline

## Field Documentation

## ◆ diffs

IntArray Lucene::BaseCharFilter::diffs

protected

## ◆ offsets

IntArray Lucene::BaseCharFilter::offsets

protected

## ◆ size

int32_t Lucene::BaseCharFilter::size

protected

The documentation for this class was generated from the following file:

- BaseCharFilter.h

clucene.sourceforge.net